USE Northwind_2020;

-- 1. Podaj identyfikator najduej realizowanego zamwienia
SELECT OrderID, datediff(DAY, OrderDate, ShippedDate) as Days
FROM Orders
ORDER BY Days DESC

SELECT OrderID, datediff(DAY, OrderDate, ShippedDate) as Days
FROM Orders
WHERE datediff(DAY, OrderDate, ShippedDate) = 
(SELECT max(datediff(DAY, OrderDate, ShippedDate)) FROM Orders)

-- 2. Poda klientw, ktrzy mieli przerw w zakupach dusz ni 2 miesice
SELECT OrderID, CustomerID, OrderDate, (
	SELECT TOP 1 OrderDate FROM Orders
	WHERE OrderID > o.OrderID AND
	CustomerID = o.CustomerID
) AS NextOrderDate,
datediff(DAY, OrderDate, (
	SELECT TOP 1 OrderDate FROM Orders
	WHERE OrderID > o.OrderID AND
	CustomerID = o.CustomerID
))
FROM Orders AS o WHERE datediff(DAY, OrderDate, (
	SELECT TOP 1 OrderDate FROM Orders
	WHERE OrderID > o.OrderID AND
	CustomerID = o.CustomerID
)) > 62


-- 3. Wypisa identyfikatory tych pracownikw, ktrzy realizowali wicej zamwie
--    ni liczba zamwie zrealizowanych przez pracownikw z tego samego kraju
--    co spedytorzy.
SELECT EmployeeID, count(OrderID) FROM Orders
GROUP BY EmployeeID
HAVING count(OrderID) >= all (
	SELECT count(OrderID) FROM Orders
	INNER JOIN Employees ON Orders.EmployeeID = Employees.EmployeeID
	WHERE Country = ShipCountry
	GROUP BY Orders.EmployeeID
)

-- 4. W firmie uywajcej bazy Northwind pracownicy (tabela Employees) posiadaj
--    adresy emialowe. Zamy, e standardowo nazwa konta (cz przed znakiem @)
--    zbudowana jest z pierwszej litery imienia (firstname), inicjau rodkowego
--    (pole middlinitial) oraz pierwszych omiu znakw nazwiska (lastname).
--    Utwrz zapytanie, ktre wygeneruje te nazwy emailowe. W tym zadaniu naley
--    uy funkcji acuchowych LOWER i SUBSTRING.
SELECT FirstName, LastName, lower(
	concat(
		substring(FirstName, 1, 1),
		substring(LastName, 1, 8),
		'@northwind.com'
	)
) FROM Employees

-- 5. Podaj dzie w ktrym byo najwicej zamwie
SELECT count(OrderID) AS HowMany, datename(weekday, OrderDate) AS WeekDay
FROM Orders
GROUP BY datename(weekday, OrderDate)
ORDER BY count(OrderID) DESC

-- 6. Wypisz nazw i adres najczciej zamawiajcego klienta -- broken
SELECT CompanyName, City
FROM Customers
WHERE CompanyName = (
SELECT CompanyName FROM Customers
INNER JOIN Orders ON Orders.CustomerID = Customers.CustomerID
HAVING count(OrderID) >= ALL (SELECT count(OrderID) FROM Orders GROUP BY CustomerID)
)



SELECT count(OrderID), Orders.CustomerID
FROM Orders
INNER JOIN Customers ON Customers.CustomerID = Orders.CustomerID
GROUP BY Orders.CustomerID

-- 7. Wskaza pracownika ktry obsugiwa klienta, ktrego nie obsugiwa nikt inny


-- 8. Wypisz dane pracownika ktrego nazwisko jest najdusze. Skorzystaj z funkcji LEN
SELECT LastName
FROM Employees
WHERE len(LastName) = (SELECT max(len(LastName)) FROM Employees)